searchNodes=[{"doc":"Defines a queues machine.A Queuetopia can manage multiple ordered blocking queues. All the queues share only the same scheduler and the poll interval. They are completely independant from each other.A Queuetopia expects a performer to exist. For example, the performer can be implemented like this:defmodule MyApp.MailQueue.Performer do @behaviour Queuetopia.Jobs.Performer @impl true def perform(%Queuetopia.Jobs.Job{action: &quot;do_x&quot;}) do do_x() end defp do_x(), do: {:ok, &quot;done&quot;} endAnd the Queuetopia:defmodule MyApp.MailQueue do use Queuetopia, repo: MyApp.Repo, performer: MyApp.MailQueue.Performer end","ref":"Queuetopia.html","title":"Queuetopia","type":"behaviour"},{"doc":"Creates a job.Job optionsA job accepts the following options::timeout - The time in milliseconds to wait for the job to finish. (default: 60_000):max_backoff - default to 24 3600 1_000:max_attempts - default to 20.Examplesiex&gt; MyApp.MailQueue.create_job(&quot;mails_queue_1&quot;, &quot;send_mail&quot;, %{email_address: &quot;toto@mail.com&quot;, body: &quot;Welcome&quot;}, [timeout: 1_000, max_backoff: 60_000])","ref":"Queuetopia.html#c:create_job/4","title":"Queuetopia.create_job/4","type":"callback"},{"doc":"","ref":"Queuetopia.Jobs.html","title":"Queuetopia.Jobs","type":"module"},{"doc":"Creates a job, specifying the performer, the Queuetopia (scope), and the user params, including options.","ref":"Queuetopia.Jobs.html#create_job/7","title":"Queuetopia.Jobs.create_job/7","type":"function"},{"doc":"Returns true if a job is done. Otherwise, returns false.","ref":"Queuetopia.Jobs.html#done?/1","title":"Queuetopia.Jobs.done?/1","type":"function"},{"doc":"Fetches a specific job. Acquires the lock on the queue and returns the job if it actually and reached it schedule time. In case of error, returns a tuple error.","ref":"Queuetopia.Jobs.html#fetch_job/2","title":"Queuetopia.Jobs.fetch_job/2","type":"function"},{"doc":"Get the next available pending job of a given queue by scope a.k.a by Queuetopia. If the queue is empty or the next pendign job is scheduled for later, returns nil.","ref":"Queuetopia.Jobs.html#get_next_pending_job/3","title":"Queuetopia.Jobs.get_next_pending_job/3","type":"function"},{"doc":"List the available pending queues by scope a.k.a by Queuetopia.","ref":"Queuetopia.Jobs.html#list_available_pending_queues/2","title":"Queuetopia.Jobs.list_available_pending_queues/2","type":"function"},{"doc":"Performs the job. Let the performer do its job.","ref":"Queuetopia.Jobs.html#perform/1","title":"Queuetopia.Jobs.perform/1","type":"function"},{"doc":"Persist in DB the result of job execution. Attempts fields are filled. In case of success, set the done_at field. Otherwise, save the error, prepare the job for a next retry, resetting the scheduled_at with the backoff calculation.","ref":"Queuetopia.Jobs.html#persist_result/3","title":"Queuetopia.Jobs.persist_result/3","type":"function"},{"doc":"Returns true if a job scheduled date is reached and the job is not done yet. Otherwise, returns false.","ref":"Queuetopia.Jobs.html#processable_now?/1","title":"Queuetopia.Jobs.processable_now?/1","type":"function"},{"doc":"Returns true if a job scheduled date is reached. Otherwise, returns false.","ref":"Queuetopia.Jobs.html#scheduled_for_now?/1","title":"Queuetopia.Jobs.scheduled_for_now?/1","type":"function"},{"doc":"","ref":"Queuetopia.Jobs.Job.html","title":"Queuetopia.Jobs.Job","type":"module"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#create_changeset/1","title":"Queuetopia.Jobs.Job.create_changeset/1","type":"function"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#default_max_attempts/0","title":"Queuetopia.Jobs.Job.default_max_attempts/0","type":"function"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#default_max_backoff/0","title":"Queuetopia.Jobs.Job.default_max_backoff/0","type":"function"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#default_timeout/0","title":"Queuetopia.Jobs.Job.default_timeout/0","type":"function"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#failed_job_changeset/2","title":"Queuetopia.Jobs.Job.failed_job_changeset/2","type":"function"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#succeeded_job_changeset/2","title":"Queuetopia.Jobs.Job.succeeded_job_changeset/2","type":"function"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#t:option/0","title":"Queuetopia.Jobs.Job.option/0","type":"type"},{"doc":"","ref":"Queuetopia.Jobs.Job.html#t:t/0","title":"Queuetopia.Jobs.Job.t/0","type":"type"},{"doc":"The behaviour for a Queuetopia performer.","ref":"Queuetopia.Jobs.Performer.html","title":"Queuetopia.Jobs.Performer","type":"behaviour"},{"doc":"Callback invoked by the Queuetopia to perfom a job. It may return :ok, an :ok tuple or a tuple error, with a string as error. Note that any failure in the processing will cause the job to be retried.","ref":"Queuetopia.Jobs.Performer.html#c:perform/1","title":"Queuetopia.Jobs.Performer.perform/1","type":"callback"},{"doc":"","ref":"Queuetopia.Locks.html","title":"Queuetopia.Locks","type":"module"},{"doc":"","ref":"Queuetopia.Locks.html#lock_queue/4","title":"Queuetopia.Locks.lock_queue/4","type":"function"},{"doc":"","ref":"Queuetopia.Locks.html#release_expired_locks/2","title":"Queuetopia.Locks.release_expired_locks/2","type":"function"},{"doc":"","ref":"Queuetopia.Locks.html#unlock_queue/3","title":"Queuetopia.Locks.unlock_queue/3","type":"function"},{"doc":"","ref":"Queuetopia.Locks.Lock.html","title":"Queuetopia.Locks.Lock","type":"module"},{"doc":"","ref":"Queuetopia.Locks.Lock.html#changeset/2","title":"Queuetopia.Locks.Lock.changeset/2","type":"function"},{"doc":"","ref":"Queuetopia.Locks.Lock.html#t:t/0","title":"Queuetopia.Locks.Lock.t/0","type":"type"},{"doc":"The Queuetopia scheduler, polling with a defined interval the next available queues.","ref":"Queuetopia.Scheduler.html","title":"Queuetopia.Scheduler","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"Queuetopia.Scheduler.html#child_spec/1","title":"Queuetopia.Scheduler.child_spec/1","type":"function"},{"doc":"","ref":"Queuetopia.Scheduler.html#start_link/1","title":"Queuetopia.Scheduler.start_link/1","type":"function"},{"doc":"","ref":"Queuetopia.Scheduler.html#t:option/0","title":"Queuetopia.Scheduler.option/0","type":"type"}]